Index: channels/iax2/parser.c
===================================================================
--- channels/iax2/parser.c	(revision 393737)
+++ channels/iax2/parser.c	(working copy)
@@ -41,6 +41,7 @@
 #include "asterisk/config.h"
 #include "asterisk/lock.h"
 #include "asterisk/threadstorage.h"
+#include "asterisk/netsock2.h"
 
 #include "include/iax2.h"
 #include "include/parser.h"
@@ -83,10 +84,18 @@
 
 static void dump_addr(char *output, int maxlen, void *value, int len)
 {
-	struct sockaddr_in sin;
-	if (len == (int)sizeof(sin)) {
+	char straddr[64];
+
+	if (len == (int)sizeof(struct sockaddr_in)) {
+		struct sockaddr_in sin;
 		memcpy(&sin, value, len);
-		snprintf(output, maxlen, "IPV4 %s:%d", ast_inet_ntoa(sin.sin_addr), ntohs(sin.sin_port));
+		inet_ntop(AF_INET, &sin.sin_addr, straddr, sizeof(straddr));
+		snprintf(output, maxlen, "IPV4 %s:%d", straddr, ntohs(sin.sin_port));
+	} else if (len == (int) sizeof(struct sockaddr_in6)) {
+		struct sockaddr_in6 sin6;
+		memcpy(&sin6, value, len);
+		inet_ntop(AF_INET6, &sin6.sin6_addr, straddr, sizeof(straddr));
+		snprintf(output, maxlen, "IPV6 [%s]:%d", straddr, ntohs(sin6.sin6_port));
 	} else {
 		ast_copy_string(output, "Invalid Address", maxlen);
 	}
@@ -172,12 +181,22 @@
 
 static void dump_ipaddr(char *output, int maxlen, void *value, int len)
 {
-	struct sockaddr_in sin;
-	if (len == (int)sizeof(unsigned int)) {
-		memcpy(&sin.sin_addr, value, len);
-		snprintf(output, maxlen, "%s", ast_inet_ntoa(sin.sin_addr));
-	} else
+	char straddr[64];
+	socklen_t sa_len = len;
+
+	if (len == (int)sizeof(struct sockaddr_in)) {
+		struct sockaddr_in sin;
+		memcpy(&sin.sin_addr, value, sa_len);
+		inet_ntop(AF_INET, &sin.sin_addr, straddr, sizeof(straddr));
+		snprintf(output, maxlen, "%s", straddr);
+	} else if (len == (int)sizeof(struct sockaddr_in6)) {
+		struct sockaddr_in6 sin6;
+		memcpy(&sin6.sin6_addr, value, sa_len);
+		inet_ntop(AF_INET6, &sin6.sin6_addr, straddr, sizeof(straddr));
+		snprintf(output, maxlen, "%s", straddr);
+	} else {
 		ast_copy_string(output, "Invalid IPADDR", maxlen);
+	}
 }
 
 
@@ -562,8 +581,10 @@
 	ast_copy_string(str, cmd, len);
 }
 
-void iax_showframe(struct iax_frame *f, struct ast_iax2_full_hdr *fhi, int rx, struct sockaddr_in *sin, int datalen)
+void iax_showframe(struct iax_frame *f, struct ast_iax2_full_hdr *fhi, int rx, struct ast_sockaddr *addr, int datalen)
 {
+#define IPV4FORMAT "   Timestamp: %05lums  SCall: %5.5d  DCall: %5.5d [%s:%s]\n"
+#define IPV6FORMAT "   Timestamp: %05lums  SCall: %5.5d  DCall: %5.5d [[%s]:%s]\n"
 	const char *framelist[] = {
 		"(0?)",
 		"DTMF_E ",
@@ -613,6 +634,7 @@
 	const char *subclass;
 	char *dir;
 	char tmp[512];
+	char *tmp_addr, *tmp_port;
 
 	switch(rx) {
 	case 0:
@@ -665,6 +687,10 @@
 		snprintf(subclass2, sizeof(subclass2), "%d", fh->csub);
 		subclass = subclass2;
 	}
+
+	tmp_addr = ast_strdupa(ast_sockaddr_stringify_addr(addr));
+	tmp_port = ast_strdupa(ast_sockaddr_stringify_port(addr));
+
 	snprintf(tmp, sizeof(tmp), 
 		 "%s-Frame Retry[%s] -- OSeqno: %3.3d ISeqno: %3.3d Type: %s Subclass: %s\n",
 		 dir,
@@ -671,13 +697,17 @@
 		 retries, fh->oseqno, fh->iseqno, class, subclass);
 	outputf(tmp);
 	snprintf(tmp, sizeof(tmp), 
-		 "   Timestamp: %05lums  SCall: %5.5d  DCall: %5.5d [%s:%d]\n",
-		 (unsigned long)ntohl(fh->ts),
+		(ast_sockaddr_is_ipv4(addr) || ast_sockaddr_is_ipv4_mapped(addr)) ? IPV4FORMAT : IPV6FORMAT,
+		(unsigned long)ntohl(fh->ts),
 		 ntohs(fh->scallno) & ~IAX_FLAG_FULL, ntohs(fh->dcallno) & ~IAX_FLAG_RETRANS,
-		 ast_inet_ntoa(sin->sin_addr), ntohs(sin->sin_port));
+		 tmp_addr, tmp_port);
+
 	outputf(tmp);
 	if (fh->type == AST_FRAME_IAX)
 		dump_ies(fh->iedata, datalen);
+
+#undef IPV4FORMAT
+#undef IPV6FORMAT
 }
 
 int iax_ie_append_raw(struct iax_ie_data *ied, unsigned char ie, const void *data, int datalen)
@@ -695,9 +725,9 @@
 	return 0;
 }
 
-int iax_ie_append_addr(struct iax_ie_data *ied, unsigned char ie, const struct sockaddr_in *sin)
+int iax_ie_append_addr(struct iax_ie_data *ied, unsigned char ie, const struct ast_sockaddr *addr)
 {
-	return iax_ie_append_raw(ied, ie, sin, (int)sizeof(struct sockaddr_in));
+	return iax_ie_append_raw(ied, ie, addr, addr->len);
 }
 
 int iax_ie_append_versioned_uint64(struct iax_ie_data *ied, unsigned char ie, unsigned char version, uint64_t value)
@@ -892,7 +922,31 @@
 			ies->rsa_result = (char *)data + 2;
 			break;
 		case IAX_IE_APPARENT_ADDR:
-			ies->apparent_addr = ((struct sockaddr_in *)(data + 2));
+			{
+				char straddr[64];
+				int portno = 0;
+
+				if (len == (int)sizeof(struct sockaddr_in)) {
+					struct sockaddr_in *sin;
+					sin = ((struct sockaddr_in *)(data + 2));
+					inet_ntop(AF_INET, &sin->sin_addr, straddr, sizeof(straddr));
+					portno = ntohs(sin->sin_port);
+				} else if (len == (int)sizeof(struct sockaddr_in6)) {
+					struct sockaddr_in6 *sin6;
+					sin6 = ((struct sockaddr_in6 *)(data + 2));
+					inet_ntop(AF_INET6, &sin6->sin6_addr, straddr, sizeof(straddr));
+					portno = ntohs(sin6->sin6_port);
+				} else {
+					snprintf(tmp, (int)sizeof(tmp), "Expecting apparent address to be %d or %d bytes long but was %d\n",
+						(int)sizeof(struct sockaddr_in), (int)sizeof(struct sockaddr_in6), len);
+					errorf(tmp);
+					break;
+				}
+
+				ast_sockaddr_parse(&ies->apparent_addr, straddr, 0);
+				ast_sockaddr_set_port(&ies->apparent_addr, portno);
+
+			}
 			break;
 		case IAX_IE_REFRESH:
 			if (len != (int)sizeof(unsigned short)) {
Index: contrib/realtime/mysql/iaxfriends.sql
===================================================================
--- contrib/realtime/mysql/iaxfriends.sql	(revision 393737)
+++ contrib/realtime/mysql/iaxfriends.sql	(working copy)
@@ -14,8 +14,8 @@
   `host` varchar(40) NULL default 'dynamic',
   `ipaddr` varchar(40) NULL, -- Must be updateable by Asterisk user
   `port` int(5) NULL, -- Must be updateable by Asterisk user
-  `defaultip` varchar(20) NULL,
-  `sourceaddress` varchar(20) NULL,
+  `defaultip` varchar(45) NULL,
+  `sourceaddress` varchar(45) NULL,
   `mask` varchar(20) NULL,
   `regexten` varchar(40) NULL,
   `regseconds` int(11) NULL, -- Must be updateable by Asterisk user
Index: include/asterisk/acl.h
===================================================================
--- include/asterisk/acl.h	(revision 393737)
+++ include/asterisk/acl.h	(working copy)
@@ -181,6 +181,23 @@
 enum ast_acl_sense ast_apply_ha(const struct ast_ha *ha, const struct ast_sockaddr *addr);
 
 /*!
+ * \brief
+ * Apply a netmask to an address and store the result in a separate structure.
+ *
+ * When dealing with IPv6 addresses, one cannot apply a netmask with a simple
+ * logical AND operation.  Futhermore, the incoming address may be an IPv4
+ * address and needs to be mapped properly before attempting to apply a rule.
+ *
+ * \param addr The IP address to apply the mask to.
+ * \param netmask The netmask configured in the host access rule.
+ * \param result The resultant address after applying the netmask to the given address
+ * \retval 0 Successfully applied netmask
+ * \retval -1 Failed to apply netmask
+ */
+int ast_apply_netmask(const struct ast_sockaddr *addr, const struct ast_sockaddr *netmask,
+		struct ast_sockaddr *result);
+
+/*!
  * \brief Apply a set of rules to a given IP address
  *
  * \details
Index: main/acl.c
===================================================================
--- main/acl.c	(revision 393737)
+++ main/acl.c	(working copy)
@@ -359,21 +359,7 @@
  */
 #define V6_WORD(sin6, index) ((uint32_t *)&((sin6)->sin6_addr))[(index)]
 
-/*!
- * \brief
- * Apply a netmask to an address and store the result in a separate structure.
- *
- * When dealing with IPv6 addresses, one cannot apply a netmask with a simple
- * logical and operation. Furthermore, the incoming address may be an IPv4 address
- * and need to be mapped properly before attempting to apply a rule.
- *
- * \param addr The IP address to apply the mask to.
- * \param netmask The netmask configured in the host access rule.
- * \param result The resultant address after applying the netmask to the given address
- * \retval 0 Successfully applied netmask
- * \retval -1 Failed to apply netmask
- */
-static int apply_netmask(const struct ast_sockaddr *addr, const struct ast_sockaddr *netmask,
+int ast_apply_netmask(const struct ast_sockaddr *addr, const struct ast_sockaddr *netmask,
 		struct ast_sockaddr *result)
 {
 	int res = 0;
@@ -693,7 +679,7 @@
 			return ret;
 		}
 
-		if (apply_netmask(&ha->addr, &ha->netmask, &ha->addr)) {
+		if (ast_apply_netmask(&ha->addr, &ha->netmask, &ha->addr)) {
 			/* This shouldn't happen because ast_sockaddr_parse would
 			 * have failed much earlier on an unsupported address scheme
 			 */
@@ -805,7 +791,7 @@
 
 		/* For each rule, if this address and the netmask = the net address
 		   apply the current rule */
-		if (apply_netmask(addr_to_use, &current_ha->netmask, &result)) {
+		if (ast_apply_netmask(addr_to_use, &current_ha->netmask, &result)) {
 			/* Unlikely to happen since we know the address to be IPv4 or IPv6 */
 			continue;
 		}
Index: main/netsock.c
===================================================================
--- main/netsock.c	(revision 393737)
+++ main/netsock.c	(working copy)
@@ -117,7 +117,7 @@
 	const int reuseFlag = 1;
 
 	/* Make a UDP socket */
-	netsocket = socket(AF_INET, SOCK_DGRAM, IPPROTO_IP);
+	netsocket = socket(ast_sockaddr_is_ipv6(bindaddr) ? AST_AF_INET6 : AST_AF_INET, SOCK_DGRAM, IPPROTO_IP);
 
 	if (netsocket < 0) {
 		ast_log(LOG_ERROR, "Unable to create network socket: %s\n", strerror(errno));
@@ -155,7 +155,7 @@
 	ns->ioc = ioc;
 	ns->sockfd = netsocket;
 	ns->data = data;
-	memcpy(&ns->bindaddr, bindaddr, sizeof(ns->bindaddr));
+	ast_sockaddr_copy(&ns->bindaddr, bindaddr);
 	ASTOBJ_CONTAINER_LINK(list, ns);
 
 	return ns;
@@ -171,10 +171,6 @@
 	struct ast_sockaddr addr;
 
 	if (ast_sockaddr_parse(&addr, bindinfo, 0)) {
-		if (!ast_sockaddr_is_ipv4(&addr)) {
-			ast_log(LOG_WARNING, "Only IPv4 addresses are supported at this time.\n");
-			return NULL;
-		}
 
 		if (!ast_sockaddr_port(&addr)) {
 			ast_sockaddr_set_port(&addr, defaultport);
